<?

/*
 * Cudo do automatycznych weryfikacji danych wszelakich.
 */
define( 'VER_TICKET' , 0 );
define( 'VER_NOT_ZERO_LENGTH_STRING' , 1 );
define( 'VER_INTEGER' , 2 );
define( 'VER_EVERYTHING' , 3 );

class Verifier
{
	function verify( $type , $value , $defaultValue )
	{
		switch( $type )
		{
			case VER_TICKET:
				return $value;
			
			case VER_NOT_ZERO_LENGTH_STRING:
				return is_string( $value ) && strlen( $value ) > 0 ? $value : $defaultValue;

			case VER_INTEGER:
				return preg_match( '/^\d+$/' , $value ) ? $value : $defaultValue;

			case VER_EVERYTHING:
				return is_null( $value ) ? $defaultValue : $value;
		}

		return $value;
	}
}

function verify( $type , $value , $defaultValue )
{
	$ver = &getVerifier();

	return $ver->verify( $type , $value , $defaultValue );
}

function verifyFromArray( $type , $array , $index , $defaultValue )
{
	if( !isset( $array[ $index ] ) )
		return $defaultValue;
	
	return verify( $type , $array[ $index ] , $defaultValue );
}

/*
 * Poniewa w _REQUEST zawsze s stringi, mona sobie pozwoli
 * na warto domyln.
 */
function verifyFromREQUEST( $type , $index , $defaultValue = '' )
{
	return verifyFromArray( $type , $_REQUEST , $index , $defaultValue );
}

function &getVerifier()
{
	global $_CMS_VERIFIER;

	if( !is_object( $_CMS_VERIFIER ) )
		$_CMS_VERIFIER = new Verifier();
	
	return $_CMS_VERIFIER;
}

?>
